import numpy as np
import matplotlib.pyplot as plt



######### PCA plot ##############
counters = np.loadtxt("./results/clustering/pca/counters.txt")
fc10 = np.loadtxt("./results/clustering/pca/fc_perc10.txt")
fc10 = 1-fc10
fc50 = np.loadtxt("./results/clustering/pca/fc_medians.txt")
fc50 = 1-fc50
fc90 = np.loadtxt("./results/clustering/pca/fc_perc90.txt")
fc90 = 1-fc90
fc_err = np.array([fc50-fc90,fc10-fc50])


lsh50 = np.loadtxt("./results/clustering/pca/lsh_medians.txt")
lsh50 = 1-lsh50
lsh10 = np.loadtxt("./results/clustering/pca/lsh_perc10.txt")
lsh10 = 1-lsh10
lsh90 = np.loadtxt("./results/clustering/pca/lsh_perc90.txt")
lsh90 = 1-lsh90
lsh_err = np.array([lsh50-lsh90,lsh10-lsh50])

fig, ax = plt.subplots(figsize=(4.4, 5))
plt.ylim(-0.03,0.85)

plt.xticks(counters, ['100','300','500','700','900'])

ax.errorbar(counters, fc50, yerr=fc_err, fmt='o', linewidth=2, capsize=6, label='FriendlyCore Clustering', color='#2ca02c')
ax.errorbar(counters, lsh50, yerr=lsh_err, fmt='o', linewidth=2, capsize=6, label='LSH Clustering', color='#d62728')


ax.set_xlabel('d')
ax.set_ylabel('Labeling Failure')
ax.set_title("k-GMM Synthetic Data (n=2.5e5, k=5)")
ax.legend()
plt.savefig('./plots/clustering-pca.png')


###########  d2 plot ##############
counters = np.loadtxt("./results/clustering/d2/counters.txt")
fc50 = np.loadtxt("./results/clustering/d2/fc_medians.txt")
fc10 = np.loadtxt("./results/clustering/d2/fc_perc10.txt")
fc90 = np.loadtxt("./results/clustering/d2/fc_perc90.txt")
fc_err = np.array([fc50-fc10,fc90-fc50])

lsh50 = np.loadtxt("./results/clustering/d2/lsh_medians.txt")
lsh10 = np.loadtxt("./results/clustering/d2/lsh_perc10.txt")
lsh90 = np.loadtxt("./results/clustering/d2/lsh_perc90.txt")
lsh_err = np.array([lsh50-lsh10,lsh90-lsh50])

fig, ax = plt.subplots(figsize=(4.4, 5))
plt.ylim(-0.03,1.01)

#counters = np.ceil(counters)
plt.xticks(counters, ['1e4','5e4','1e5','2e5','3e5','4e5'])

ax.errorbar(counters, fc50, yerr=fc_err, fmt='o', linewidth=2, capsize=6, label='FriendlyCore Clustering', color='#2ca02c')
ax.errorbar(counters, lsh50, yerr=lsh_err, fmt='o', linewidth=2, capsize=6, label='LSH Clustering', color='#d62728')

ax.set_xlabel('n')
ax.set_ylabel('Normalized k-Means Loss')
ax.set_title("k-Means Synthetic Data (d=2, k=8)")
ax.legend()
plt.savefig('./plots/clustering-d2.png')


########################################

###########   gas plot  ##############
counters = np.loadtxt("./results/clustering/gas/counters.txt")
fc50 = np.loadtxt("./results/clustering/gas/fc_medians.txt")
fc10 = np.loadtxt("./results/clustering/gas/fc_perc10.txt")
fc90 = np.loadtxt("./results/clustering/gas/fc_perc90.txt")
fc_err = np.array([fc50-fc10,fc90-fc50])

lsh50 = np.loadtxt("./results/clustering/gas/lsh_medians.txt")
lsh10 = np.loadtxt("./results/clustering/gas/lsh_perc10.txt")
lsh90 = np.loadtxt("./results/clustering/gas/lsh_perc90.txt")
lsh_err = np.array([lsh50-lsh10,lsh90-lsh50])
fig, ax = plt.subplots(figsize=(4.4, 5))
plt.ylim(-0.03,0.6)

counters = np.ceil(counters)
plt.xticks(counters, ['2','3','4','5','6'])

ax.errorbar(counters, fc50, yerr=fc_err, fmt='o', linewidth=2, capsize=6, label='FriendlyCore Clustering', color='#2ca02c')
ax.errorbar(counters, lsh50, yerr=lsh_err, fmt='o', linewidth=2, capsize=6, label='LSH Clustering', color='#d62728')

ax.set_xlabel('k')
ax.set_ylabel('Normalized k-Means Loss')
ax.set_title("k-Means Gas Sensors (n=8M, d=16)")
ax.legend()
plt.savefig('./plots/clustering-gas.png')

print("Done!")