import numpy as np
import matplotlib.pyplot as plt


########## Google Experiment ##############

#### Increasing R plot
counters = np.loadtxt("./results/synthetic_mean/counters-R.txt")
t50_coinpress = np.loadtxt("./results/synthetic_mean/t50_coinpress-R.txt")
t20_coinpress = np.loadtxt("./results/synthetic_mean/t20_coinpress-R.txt")
t40_coinpress = np.loadtxt("./results/synthetic_mean/t40_coinpress-R.txt")
t4_coinpress = np.loadtxt("./results/synthetic_mean/t4_coinpress-R.txt")
fc_avg = np.loadtxt("./results/synthetic_mean/fc_avg-R.txt")

fig, ax = plt.subplots()
ax.plot(counters, t20_coinpress, marker="x", label='CoinPress (20 iterations)', color='#8c564b')
ax.plot(counters, t40_coinpress, marker="x", label='CoinPress (40 iterations)')
ax.plot(counters, t4_coinpress, marker="x", label='CoinPress (4 iterations)', color='#d62728')
ax.plot(counters, fc_avg, marker="x", label='FriendlyCore Average', color='#2ca02c')
plt.xlim(2.2,9)
plt.ylim(2,30)
ax.set_xlabel('log10(R)')
ax.set_ylabel('L2 error')
ax.set_title("Averaging (Effect of Increasing R)")
ax.legend()
plt.savefig('./plots/R.png')




#### Increasing d plot
counters = np.loadtxt("./results/synthetic_mean/counters-d.txt")
t2_coinpress = np.loadtxt("./results/synthetic_mean/t2_coinpress-d.txt")
t4_coinpress = np.loadtxt("./results/synthetic_mean/t4_coinpress-d.txt")
t8_coinpress = np.loadtxt("./results/synthetic_mean/t8_coinpress-d.txt")
fc_avg = np.loadtxt("./results/synthetic_mean/fc_avg-d.txt")

fig, ax = plt.subplots()
ax.plot(counters, t2_coinpress, marker="x", label='CoinPress (2 iterations)', color='#8c564b')
ax.plot(counters, t4_coinpress, marker="x", label='CoinPress (4 iterations)', color='#d62728')
ax.plot(counters, t8_coinpress, marker="x", label='CoinPress (8 iterations)', color='#bcbd22')
ax.plot(counters, fc_avg, marker="x", label='FriendlyCore Average', color='#2ca02c')
plt.ylim(0.0,45)
ax.set_xlabel('d')
ax.set_ylabel('L2 error')
ax.set_title("Averaging (Effect of Increasing d)")
ax.legend()
plt.savefig('./plots/d.png')



#### Increasing n plot
counters = np.loadtxt("./results/synthetic_mean/counters-n.txt")
kv = np.loadtxt("./results/synthetic_mean/kv-n.txt")
t2_coinpress = np.loadtxt("./results/synthetic_mean/t2_coinpress-n.txt")
t4_coinpress = np.loadtxt("./results/synthetic_mean/t4_coinpress-n.txt")
fc_avg = np.loadtxt("./results/synthetic_mean/fc_avg-n.txt")

fig, ax = plt.subplots()
ax.plot(counters, kv, marker="x", label='KV', color='#bcbd22')
ax.plot(counters, t4_coinpress, marker="x", label='CoinPress (4 iterations)', color='#d62728')
ax.plot(counters, fc_avg, marker="x", label='FriendlyCore Average', color='#2ca02c')
plt.ylim(0.0,0.6)
ax.set_xlabel('n')
ax.set_ylabel('L2 error')
ax.set_title("Averaging (Effect of Increasing n)")
ax.legend()
plt.savefig('./plots/n.png')

print("Done!")